<?php

namespace Cas\Result\Http\Controllers;

use App\Http\Controllers\PublicController as BaseController;
use Cas\Result\Interfaces\ResultRepositoryInterface;

class ResultPublicController extends BaseController
{
    // use ResultWorkflow;

    /**
     * Constructor.
     *
     * @param type \Cas\Result\Interfaces\ResultRepositoryInterface $result
     *
     * @return type
     */
    public function __construct(ResultRepositoryInterface $result)
    {
        $this->repository = $result;
        parent::__construct();
    }

    /**
     * Show result's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $results = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();


        return $this->response->setMetaTitle(trans('$result::result.names'))
            ->view('result::result.index')
            ->data(compact('results'))
            ->output();
    }


    /**
     * Show result.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $result = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->response->setMetaTitle($$result->name . trans('result::result.name'))
            ->view('result::result.show')
            ->data(compact('result'))
            ->output();
    }

}
