<?php

namespace Cas\Result\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class ResultTransformer extends TransformerAbstract
{
    public function transform(\Cas\Result\Models\Result $result)
    {
        return [
            'id'                => $result->getRouteKey(),
            'key'               => [
                'public'    => $result->getPublicKey(),
                'route'     => $result->getRouteKey(),
            ], 
            'id'                => $result->id,
            'agent_id'          => $result->agent_id,
            'project_id'        => $result->project_id,
            'details'           => $result->details,
            'documents'         => $result->documents,
            'created_at'        => $result->created_at,
            'updated_at'        => $result->updated_at,
            'deleted_at'        => $result->deleted_at,
            'url'               => [
                'public'    => trans_url('result/'.$result->getPublicKey()),
                'user'      => guard_url('result/result/'.$result->getRouteKey()),
            ], 
            'status'            => trans('app.'.$result->status),
            'created_at'        => format_date($result->created_at),
            'updated_at'        => format_date($result->updated_at),
        ];
    }
}