<?php

namespace Cas\Result;

use User;

class Result
{
    /**
     * $result object.
     */
    protected $result;

    /**
     * Constructor.
     */
    public function __construct(\Cas\Result\Interfaces\ResultRepositoryInterface $result)
    {
        $this->result = $result;
    }

    /**
     * Returns count of result.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.result.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->result->pushCriteria(new \Litepie\Cas\Repositories\Criteria\ResultUserCriteria());
        }

        $result = $this->result->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('result::' . $view, compact('result'))->render();
    }
}
